{-# LANGUAGE DeriveDataTypeable, FlexibleContexts, FlexibleInstances, MultiParamTypeClasses, ScopedTypeVariables, TemplateHaskell #-}
{-# OPTIONS_GHC -fallow-undecidable-instances #-}
-- {-# OPTIONS_GHC -F -pgmFtrhsx -fglasgow-exts -Wwarn -fwarn-unused-imports -fallow-undecidable-instances -fallow-incoherent-instances -fwarn-missing-signatures #-}
module Interface where

import HSP.Formlets
import HSP
import HAppS.Template.HSP

import Data.Generics.SYB.WithClass.Basics
import Data.Generics.SYB.WithClass.Instances ()
import Data.Set
import HAppS.Data (Default(..), deriveAll, DefaultD(..))
import HSP

data Date = Date {month :: Integer, day :: Integer} deriving Show

validDate :: Date -> Bool
validDate (Date m d) = m `elem` [1..12] && d `elem` [1..31]

$(deriveAll [''Read, ''Show, ''Default, ''Ord, ''Eq]
  [d|
      data Sample
          = Constructor1 { anInteger :: Maybe Integer,
                           aString :: String }
          | Constructor2 { anotherString :: String,
                           aFloat :: Float,
                           aBool :: Bool,
                           aList :: [Int],
                           aRecord :: Sample2 }
          | Constructor3

      data Sample2
          = Constructor4 { int4 :: Int
                         , char4 :: Char
                         , string4 :: String }
          | Constructor5 { bool4 :: Bool }

      data Sample3 = Constructor6 { int5 :: Integer, string5 :: String }
   |])
